import { infer } from '../generic/infer'
import { Dependencies, Signature } from '../interfaces/type'

export type multiplyDep<T> = Dependencies<'multiply', T>

export const square1 =
   <T>(dep: Dependencies<'multiply', T>): Signature<'square', T> =>
   z => dep.multiply(z, z)

export const square2 = infer(<T>(dep: {
  multiply: (a: number, b: number) => number,
  unaryMinus: (x: number) => number, // just for the experiment
}): (a: number) => number =>
  z => dep.multiply(z, z)
)
